/* ̧قDoxygenpɏĂ܂B*/
/*! \file *********************************************************************
 *
 * \brief
 * PID䕔
 *
 * ̧قAVR221pLqɊPID䕔܂݂܂B
 *
 * \par Application note:
 * AVR447: ATmega48/88/168gp3ivӰ̐쓮
 *
 * \par Documentation
 * IȺގAxׁ߲A߲אݒAx޲ɂĂreadme.html
 * B
 *
 * \author
 * Atmel Corporation: http://www.atmel.com \n
 * xEҰ: avr@atmel.com
 *
 * $Name: RELEASE_1_0 $
 * $Revision: 1.2 $
 * $RCSfile: pid.c,v $
 * $Date: 2006/03/16 08:00:21 $  \n
 ******************************************************************************/

#include <ioavr.h>
#include "stdint.h"
#include "pid.h"

/*! \brief PID䕔ڏ
 *
 * PIDZ@ɂĎgpϐ
 *
 *  \param p_factor	ፀ
 *  \param i_factor	ϕ
 *  \param d_factor	
 *  \param pid		PID\
 */
void PID_Init(int16_t p_factor, int16_t i_factor, int16_t d_factor, pidData_t *pid)
{ // PID퍀ڏݒ
  // PID䕔pl
  pid->sumError = 0;								// ϕł̌덷̑a
  pid->lastProcessValue = 0;						// l̔p̍ŏIl
  // PIDHp萔
  pid->P_Factor = p_factor;							// (~100)ᒲ萔
  pid->I_Factor = i_factor;							// (~100)ϕ萔
  pid->D_Factor = d_factor;							// (~100)萔
  // 邽߂̐
  pid->maxError = MAX_INT / pid->P_Factor;			// h~ő勖e덷
  pid->maxSumError = MAX_I_TERM / pid->I_Factor;	// h~ő勖ea덷
}

/*! \brief PID䉉Z@
 *
 * ݒ_AlAPIDԂo͌vZ
 *
 *  \param setPoint		vꂽl
 *  \param processValue	肳ꂽl
 *  \param pid_st		PIDԍ\
 */
int16_t PID_Controller(int16_t setPoint, int16_t processValue, pidData_t *pid_st)
{
  int16_t error, p_term, d_term;
  int32_t i_term;
  int32_t ret;
  int32_t temp;

  error = setPoint - processValue;					// vlƑlԂ̌덷擾

  // ፀvZƌ덷ꐧ
  if (error > pid_st->maxError)						// ̕e덷zŁA
  {
    p_term = MAX_INT;								// ፀPx^̐̍őlɐ
  }
  else if (error < -pid_st->maxError)				// ̕e덷zŁA
  {
    p_term = -MAX_INT;								// ፀPx^̍̕őlɐ
  }
  else												// xŁA
  {
    p_term = pid_st->P_Factor * error;				// ፀ擾
  }
  // ϕvZƐϕ\
  temp = pid_st->sumError + error;					// 񑍘aꎞϐɎ擾
  if(temp > pid_st->maxSumError)					// ̕ea덷zŁA
  {
    i_term = MAX_I_TERM;							// ϕp̔{x^̐̍őlɐ
    pid_st->sumError = pid_st->maxSumError;			// 񑍘aƂĐ̕ea덷ݒ
  }
  else if(temp < -pid_st->maxSumError)				// ̕ea덷zŁA
  {
    i_term = -MAX_I_TERM;							// ϕp̔{x^̍̕őlɐ
    pid_st->sumError = -pid_st->maxSumError;		// 񑍘aƂĕ̕ea덷ݒ
  }
  else												// xŁA
  {
    pid_st->sumError = temp;						// 񑍘aXV
    i_term = pid_st->I_Factor * pid_st->sumError;	// ϕ擾
  }
  // vZ
  d_term = pid_st->D_Factor * (pid_st->lastProcessValue - processValue);
  pid_st->lastProcessValue = processValue;			// ŏIlXV

  ret = (p_term + i_term + d_term) / SCALING_FACTOR;	// (W)擾
  if(ret > MAX_INT)									// ʂ̕Px^őlzŁA
  {
    ret = MAX_INT;									// ʂƂĐ̕Px^őlݒ
  }
  else if(ret < -MAX_INT)							// ʂ̕Px^őlzŁA
  {
    ret = -MAX_INT;									// ʂƂĕ̕Px^őlݒ
  }
  return((int16_t)ret);								// ʂƋɕA
}

/*! \brief ϕؾ
 *
 * {֐ĂяoPID̐ϕؾĂ܂B
 */
void PID_Reset_Integrator(pidData_t *pid_st)
{
  pid_st->sumError = 0;								// 덷a
}
